#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "6legs.h"
#include "6legs_offline.h"

double dtt = 0.03191; //    1/ (47Hz * 8) * 12ch

/************************************************************/
/**  Q_̍W^ƁÅԂԒOԂB    **/
/**  n_ƂI_֌ēxŉ^                  **/
/**  ^[o[@|@P܂Ńf[^Ă        **/
/**  coo_wav1 :O_@@                                **/
/**  vel[0]   :n_ł̑x                                **/
/**  vel[0]   :I_ł̑x                                **/
/************************************************************/
int	orbit_strait2(struct FOOT_PATH foot_path, double coo_wav1[WAVE_MAX2][3], double vel[2])
{
int     i,j,num;
double	vx, vy, vz, dist, dist2;
double	a, v, PI, total_time;
double	coo_work[2][3];

PI = 3.141592;
	//nI_̃Rs[(Ip)
	for(i = 0; i < 2; i++)
	{
		for(j = 0; j < 3; j++)
		{
			coo_work[i][j] = foot_path.coo[i][j];
		}
	}

	dist = dist_2points3D(coo_work);

	
	//n_ƏI_vĂ鎞̗O
	if(dist == 0.0)
	{
		for(j = 0; j < 3; j++)
		{
			coo_wav1[0][j] = foot_path.coo[0][j];
		}
		return(1);
	}

	//ÖقdttPʎԂƍlĂ
	total_time = dist * 2.0 / (vel[0] + vel[1]);
	a = (vel[1] - vel[0]) / total_time;

	//n_I_ւ̃xNg(PʃxNg)
	vx = (foot_path.coo[1][0] - foot_path.coo[0][0]) / dist;
	vy = (foot_path.coo[1][1] - foot_path.coo[0][1]) / dist;
	vz = (foot_path.coo[1][2] - foot_path.coo[0][2]) / dist;

	coo_wav1[0][0] = foot_path.coo[0][0];
	coo_wav1[0][1] = foot_path.coo[0][1];
	coo_wav1[0][2] = foot_path.coo[0][2];
	num = 1;
	v = vel[0];
	do{
		  coo_wav1[num][0] = coo_wav1[num - 1][0] + v * vx;
		  coo_wav1[num][1] = coo_wav1[num - 1][1] + v * vy;
		  coo_wav1[num][2] = coo_wav1[num - 1][2] + v * vz;

		  //n_̃Rs[(Ip)
		  coo_work[1][0] = coo_wav1[num][0];
		  coo_work[1][1] = coo_wav1[num][1];
		  coo_work[1][2] = coo_wav1[num][2];
		  dist2 = dist_2points3D(coo_work);

		  num++;
		  if(num > (int)WAVE_MAX2)
		  {
			  printf("G[Izg܂B(orbit_strait1)");
			  return(-1);
		  }

		  v = v + a;
	}while(dist2 < dist);

	return(num);
}

/************************************************************/
/**  Q_̍W^ƁÅԂԒOԂB    **/
/**  n_ƏI_ł͑x[                                **/
/**  ^[o[@|@P܂Ńf[^Ă        **/
/**  coo_wav1 :O_@@                                **/
/************************************************************/
int	orbit_strait1(struct FOOT_PATH foot_path, double coo_wav1[WAVE_MAX2][3])
{
int     i,j,num;
double	vx, vy, vz, dist, dist2;
double	a, t, v, dt_rad, PI;
double	coo_work[2][3];

PI = 3.141592;

	//nI_̃Rs[(Ip)
	for(i = 0; i < 2; i++)
	{
		for(j = 0; j < 3; j++)
		{
			coo_work[i][j] = foot_path.coo[i][j];
		}
	}

	dist = dist_2points3D(coo_work);
	
	//n_ƏI_vĂ鎞̗O
	if(dist == 0.0)
	{
		for(j = 0; j < 3; j++)
		{
			coo_wav1[0][j] = foot_path.coo[0][j];
		}
		return(1);
	}

	//n_I_ւ̃xNg(PʃxNg)
	vx = (foot_path.coo[1][0] - foot_path.coo[0][0]) / dist;
	vy = (foot_path.coo[1][1] - foot_path.coo[0][1]) / dist;
	vz = (foot_path.coo[1][2] - foot_path.coo[0][2]) / dist;

	dt_rad = 2.0 * PI / (foot_path.time / dtt);
	t = dt_rad;
	coo_wav1[0][0] = foot_path.coo[0][0];
	coo_wav1[0][1] = foot_path.coo[0][1];
	coo_wav1[0][2] = foot_path.coo[0][2];
	num = 1;
	a = dist / foot_path.time;
	do{
		  v = - (a * cos(t)) + a;
		  coo_wav1[num][0] = coo_wav1[num - 1][0] + v * vx * dtt;
		  coo_wav1[num][1] = coo_wav1[num - 1][1] + v * vy * dtt;
		  coo_wav1[num][2] = coo_wav1[num - 1][2] + v * vz * dtt;

		  //n_̃Rs[(Ip)
		  coo_work[1][0] = coo_wav1[num][0];
		  coo_work[1][1] = coo_wav1[num][1];
		  coo_work[1][2] = coo_wav1[num][2];
		  dist2 = dist_2points3D(coo_work);

		  t = t + dt_rad;
		  num++;
		  if(num > (int)WAVE_MAX2)
		  {
			  printf("G[Izg܂B(orbit_strait1)");
			  return(-1);
		  }
	}while(dist2 < dist);

	return(num);
}

